#include <Servo.h>

#include <itogmassiveforarduino.h>



//область глобальный переменных
Servo servo_gorizontal, servo_vertical;
bool new_data = false;
int mins = 700;
int maxs = 2300;
double norma = (double) 1 / (maxs - mins);
bool first = true;

double Ta;

//Mlx90620
//int nastroyka_from_PC;
//int oscillator_trim_from_PC;

//micromas
int yvelichenie;
int servo_payza;
int micro_shag;

//macromas
int payza_chteniya_RAM;
int nachalo_vertical;
int kolichestvo_vertical;
int shag_vertical;
int nachalo_gorizontal;
int kolichestvo_gorizontal;
int shag_gorizontal;
int temp_obj;
int temp_atmos;
int comp_osc_trim;

bool DayMas = false;


//область прототипов
class ItogMassiv;
void configurator_termoscana(String );
void ChtenieEEPROMvMassive256(int *, int , int);
void PolychaemMatricy16x4(double To[4][16], int , int, int );
void MicroMassive(ItogMassiv* , int , int , int , bool, int);
void MacroMassive(ItogMassiv& , int , int , int , int ,
                  int , int , int , int , int , int );



void setup()
{
  Wire.begin();
  Serial.begin(115200);

  servo_gorizontal.attach(10, mins, maxs, false);
  servo_vertical.attach(9, mins, maxs, false);


  double massive4x16[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      massive4x16[i][j] = 0;
    }
  }
  PolychaemMatricy16x4(massive4x16, 4, 16, 0);
  first = false;

}

void loop()
{
  //Ожидание получения команды
  String command_from_PC;
  while (Serial.available() > 0)
  {
    char symbol = Serial.read();
    command_from_PC += symbol;
    new_data = true;
  }
  //передаем команду для анализа
  if (new_data)
  {
    new_data = false;
    configurator_termoscana(command_from_PC);
  }


  //получение и передача матрицы с температурой
  if (DayMas)
  {

    ItogMassiv macromas;
    DayMas = false;
    MacroMassive(macromas, yvelichenie, servo_payza, micro_shag,
                 payza_chteniya_RAM, nachalo_vertical, nachalo_gorizontal,
                 kolichestvo_vertical, kolichestvo_gorizontal,
                 shag_vertical, shag_gorizontal);


    double buf[1];

    bool exit = false;
    bool povtor = true;
    bool prishlo = false;
    String yvedomlenie;
    while (!exit)
    {
      if (povtor)
      {
        for (int i = 0; i < macromas.x(); i++)
        {
          for (int j = 0; j < macromas.y(); j++)
          {
            buf[0] = macromas.getTemp(i, j);
            Serial.write((uint8_t*)buf, sizeof(buf));
          }
        }
        buf[0] = Ta;
        Serial.write((uint8_t*)buf, sizeof(buf));
        povtor = false;
      }

      while (Serial.available() > 0)
      {
        prishlo = true;
        char symbol = Serial.read();
        yvedomlenie += symbol;
      }
      if (prishlo && (yvedomlenie == "1"))
      {
        povtor = true;
        prishlo = false;
        yvedomlenie = "";
      }
      if (prishlo && (yvedomlenie == "0"))
        exit = true;

    }
  }

}




//ФУНКЦИИ
void configurator_termoscana(String command_from_PC)
{
  if (command_from_PC.startsWith("day matricy"))
  {
    String chislo;
    String buf = "day matricy";
    buf = command_from_PC.substring(buf.length() + 1);


    //micromas
    yvelichenie = buf.toInt();
    chislo = String(yvelichenie);;
    buf = buf.substring(chislo.length() + 1);

    servo_payza = buf.toInt();
    chislo = String(servo_payza);
    buf = buf.substring(chislo.length() + 1);

    micro_shag = buf.toInt();
    chislo = String(micro_shag);
    buf = buf.substring(chislo.length() + 1);


    //macromas
    payza_chteniya_RAM = buf.toInt();
    chislo = String(payza_chteniya_RAM);
    buf = buf.substring(chislo.length() + 1);

    nachalo_vertical = buf.toInt();
    chislo = String(nachalo_vertical);
    buf = buf.substring(chislo.length() + 1);

    kolichestvo_vertical = buf.toInt();
    chislo = String(kolichestvo_vertical);
    buf = buf.substring(chislo.length() + 1);

    shag_vertical = buf.toInt();
    chislo = String(shag_vertical);
    buf = buf.substring(chislo.length() + 1);

    nachalo_gorizontal = buf.toInt();
    chislo = String(nachalo_gorizontal);
    buf = buf.substring(chislo.length() + 1);

    kolichestvo_gorizontal = buf.toInt();
    chislo = String(kolichestvo_gorizontal);
    buf = buf.substring(chislo.length() + 1);

    shag_gorizontal = buf.toInt();
    chislo = String(shag_gorizontal);
    buf = buf.substring(chislo.length() + 1);

    temp_obj = buf.toInt();
    chislo = String(temp_obj);
    buf = buf.substring(chislo.length() + 1);

    temp_atmos = buf.toInt();
    chislo = String(temp_atmos);
    buf = buf.substring(chislo.length() + 1);
    
    comp_osc_trim = buf.toInt();
    chislo = String(comp_osc_trim);
    buf = buf.substring(chislo.length() + 1);



    DayMas = true;
  }

}

void ChtenieEEPROMvMassive256(int *EEPROM_information, int size)
{
  if (size < 256) return;
  //чтение данных из EEPROM в массив
  Wire.beginTransmission(0x50);
  Wire.write(0x00);
  Wire.endTransmission(false);

  Wire.requestFrom(80, 255);
  for (int i = 0; i < 128; i++)
  {
    EEPROM_information[i] = Wire.read();
  }

  Wire.requestFrom(81, 128);
  for (int i = 128; i < 256; i++)
  {
    EEPROM_information[i] = Wire.read();
  }
}

void PolychaemMatricy16x4(double To[4][16], int x_size, int y_size, int payza_chteniya_RAM)
{
  if (x_size != 4) return;
  if (y_size != 16) return;


  int EEPROM_information[256];
  //помещение в массив значений из EEPROM (убрать в макро)
  ChtenieEEPROMvMassive256(EEPROM_information, 256);

  //конфигурационные значения
  int CFG_L;
  if (first) CFG_L = EEPROM_information[0xF5];
  else CFG_L = temp_obj;
  int CFG_L_check = CFG_L - 0x55;

  int CFG_H;
  if (first) CFG_H = EEPROM_information[0xF6];
  else CFG_H = temp_atmos;
  int CFG_H_check = CFG_H - 0x55;

  int OSC_trim;
  if (first) OSC_trim = EEPROM_information[0xF7];
  else OSC_trim = comp_osc_trim;
  int OSC_trim_check = OSC_trim - 0xAA;

  //Настройка конфигурации
  //частота
  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x04); //command
  Wire.write(OSC_trim_check); //control LSByte
  Wire.write(OSC_trim); //LSByte
  Wire.write(0x56); //control MSByte
  Wire.write(0x00); //MSByte
  Wire.endTransmission();

  //регистр
  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x03); //command
  Wire.write(CFG_L_check); //control LSByte
  Wire.write(CFG_L); //LSByte
  Wire.write(CFG_H_check); //control MSByte
  Wire.write(CFG_H); //MSByte
  Wire.endTransmission();
  //---------------------------------

  delay (payza_chteniya_RAM);
  //Получение данных из RAM
  //Определение PTAT_data
  int PTAT_data;

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x90); //start adress
  Wire.write(0x00); //step
  Wire.write(0x01); //byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 2);
  int PTAT_L = Wire.read();
  int PTAT_H = Wire.read();

  PTAT_data = 256 * PTAT_H + PTAT_L;

  //ИК массив
  int VIR[4][16];

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x00); //start adress
  Wire.write(0x01); //step
  Wire.write(0x40); //byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 128);
  int i = 0, j = 0;
  while (Wire.available())
  {
    if (i == 4)
    {
      i = 0;
      j++;
    }

    int IR_L = Wire.read();
    int IR_H = Wire.read();

    VIR[i][j] = 256 * IR_H + IR_L;
    if (VIR[i][j] > 32767) VIR[i][j] = VIR[i][j] - 65536;
    i++;
  }

  //Компенсация
  int VCP;

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x91); //start adress
  Wire.write(0x00); //step
  Wire.write(0x01); // byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 2);
  int VCP_L = Wire.read();
  int VCP_H = Wire.read();

  VCP = 256 * VCP_H + VCP_L;
  if (VCP > 32767) VCP = VCP - 65536;
  //---------------------------------------



  //Инициализируем константы из EEPROM и другие
  int Ta_0 = 25;


  int VTH_L = EEPROM_information[0xDA];
  int VTH_H = EEPROM_information[0xDB];
  int VTH = 256 * VTH_H + VTH_L;
  if (VTH > 32767) VTH = VTH - 65536;


  int KT1_L = EEPROM_information[0xDC];
  int KT1_H = EEPROM_information[0xDD];
  int KT1_int = 256 * KT1_H + KT1_L;
  if (KT1_int > 32767) KT1_int = KT1_int - 65536;
  double KT1 = (double)KT1_int / 1024;


  int KT2_L = EEPROM_information[0xDE];
  int KT2_H = EEPROM_information[0xDF];
  int KT2_int = 256 * KT2_H + KT2_L;
  if (KT2_int > 32767) KT2_int = KT2_int - 65536;
  double KT2 = (double)KT2_int / 1048576;


  int A[4][16];
  int B[4][16];
  int da[4][16];

  int cx = 0;
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      A[i][j] = EEPROM_information[cx];
      if (A[i][j] > 127) A[i][j] = A[i][j] - 256;

      B[i][j] = EEPROM_information[0x40 + cx];
      if (B[i][j] > 127) B[i][j] = B[i][j] - 256;

      da[i][j] = EEPROM_information[0x80 + cx];
      cx++;
    }
  }

  //ЗАПЛАТКА для конкретного битого пикселя одного датчика
  A[0][0] = A[3][0];
  da[0][0] = da[3][0];
  //--------


  int ACP = EEPROM_information[0xD4];
  if (ACP > 127) ACP = ACP - 256;


  int BCP = EEPROM_information[0xD5];
  if (BCP > 127) BCP = BCP - 256;


  int aCP_L = EEPROM_information[0xD6];
  int aCP_H = EEPROM_information[0xD7];
  int aCP = 256 * aCP_H + aCP_L;


  int TGC;
  if (first) TGC = EEPROM_information[0xD8];
  else
  {
    Wire.beginTransmission(0x60); //slave address
    Wire.write(0x02); //command
    Wire.write(0x91); //start adress
    Wire.write(0x00); //step
    Wire.write(0x01); // byte to read
    Wire.endTransmission(false);

    Wire.requestFrom(0x60, 2);
    int TGC_L = Wire.read();
    int TGC_H = Wire.read();

    TGC = TGC_L;
  }
  if (TGC > 127) TGC = TGC - 256;


  int Bi_scale = EEPROM_information[0xD9];


  int a0_L = EEPROM_information[0xE0];
  int a0_H = EEPROM_information[0xE1];
  int a0 = 256 * a0_H + a0_L;


  int a0_scale = EEPROM_information[0xE2];


  int da_scale = EEPROM_information[0xE3];


  int E_L = EEPROM_information[0xE4];
  int E_H = EEPROM_information[0xE5];
  double E = (256 * E_H + E_L) / 32768;
  //---------------------------------------------





  //Вычисление температуры и вывод
  //Определение Та
  Ta = (-KT1 + sqrt(KT1 * KT1 - 4 * KT2 * (VTH - PTAT_data))) / (2 * KT2) + Ta_0;
  //--------------------------------------------





  //Определение смещения
  double VCP_off_comp = VCP - (ACP + BCP * (Ta - Ta_0) / pow(2, Bi_scale));

  double VIR_off_comp[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_off_comp[i][j] = VIR[i][j] - (A[i][j] + B[i][j] * (Ta - Ta_0) / pow(2, Bi_scale));
    }
  }
  //------------------------------------





  //Определение термоградиента
  double VIR_TGC_comp[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_TGC_comp[i][j] = VIR_off_comp[i][j] - ((TGC / 32) * VCP_off_comp);
    }
  }
  //------------------------------------





  //Компенсация излучения
  double VIR_compensated[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_compensated[i][j] = VIR_TGC_comp[i][j] / E;
    }
  }
  //------------------------------------





  //Определение альфы
  double a[4][16];
  double a_const = (a0 - TGC * aCP / 32) / pow(2, a0_scale);
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      a[i][j] = a_const + da[i][j] / pow(2, da_scale);
    }
  }
  //------------------------------------





  //Расчет To - итоговый массив температур объектов
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      To[i][j] = pow(VIR_compensated[i][j] / a[i][j] + pow(Ta + 273.15, 4), (double)1 / 4) - 273.15;
    }
  }
  //------------------------------------
}

void MicroMassive(ItogMassiv &micro_massive, int yvelichenie, int servo_payza, int micro_shag, bool macro_vpravo,
                  int payza_chteniya_RAM)
{


  //создаем итоговую микроматрицу
  micro_massive.createMicroMatrica(yvelichenie);

  //создаем элементарный массив
  double massive4x16[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      massive4x16[i][j] = 0;
    }
  }


  //запоминаем начальное положения датчика
  int nachalo_gorizontal_servo = servo_gorizontal.readMicroseconds();
  int nachalo_vertical_servo = servo_vertical.readMicroseconds();

  //цикл заполнения итогового массив
  bool gorizontal_servo_vpravo = true;
  for (int nomer_matricy_4x16 = 0;
       nomer_matricy_4x16 < yvelichenie * yvelichenie; nomer_matricy_4x16++)
  {
    //заполняем элементарный массив значениями температур
    PolychaemMatricy16x4(massive4x16, 4, 16, payza_chteniya_RAM);

    //определяем и заполняем нужную часть микромассива
    micro_massive.setMicroMatrica(massive4x16, nomer_matricy_4x16);

    //передвижения серво
    int positions, new_positions, ABS;
    if (gorizontal_servo_vpravo && (nomer_matricy_4x16 + 1) % yvelichenie != 0)
    {
      positions = servo_gorizontal.readMicroseconds();
      new_positions = positions - micro_shag;

      servo_gorizontal.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);
    }
    if (!gorizontal_servo_vpravo && (nomer_matricy_4x16 + 1) % yvelichenie != 0)
    {
      positions = servo_gorizontal.readMicroseconds();
      new_positions = positions + micro_shag;

      servo_gorizontal.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);
    }

    //перемещение вниз
    if ((nomer_matricy_4x16 + 1) != yvelichenie * yvelichenie &&
        (nomer_matricy_4x16 + 1) % yvelichenie == 0)
    {
      positions = servo_vertical.readMicroseconds();
      new_positions = positions - micro_shag;

      servo_vertical.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);

      gorizontal_servo_vpravo = !gorizontal_servo_vpravo;
    }
  }

  //возвращаем крайне правое, верхнее положения датчика из использованных

  if (macro_vpravo)
  {
    int vert_positions = servo_vertical.readMicroseconds();
    int gor_positions = servo_gorizontal.readMicroseconds();

    servo_gorizontal.writeMicroseconds(nachalo_gorizontal_servo - micro_shag * (yvelichenie - 1));
    servo_vertical.writeMicroseconds(nachalo_vertical_servo);

    int ABS1 = abs(vert_positions - nachalo_vertical_servo);
    int ABS2 = abs(gor_positions - (nachalo_gorizontal_servo - micro_shag * (yvelichenie - 1)));
    delay (servo_payza * ABS1 * norma + servo_payza * ABS2 * norma);
  }
  else
  {
    int vert_positions = servo_vertical.readMicroseconds();
    int gor_positions = servo_gorizontal.readMicroseconds();

    servo_gorizontal.writeMicroseconds(nachalo_gorizontal_servo);
    servo_vertical.writeMicroseconds(nachalo_vertical_servo);

    int ABS1 = abs(vert_positions - nachalo_vertical_servo);
    int ABS2 = abs(gor_positions - nachalo_gorizontal_servo);
    delay (servo_payza * ABS1 * norma + servo_payza * ABS2 * norma);
  }
}

void MacroMassive(ItogMassiv &macro_massive, int yvelichenie, int servo_payza, int micro_shag,
                  int payza_chteniya_RAM,

                  int nachalo_vertical,
                  int nachalo_gorizontal,

                  int kolichestvo_vertical,
                  int kolichestvo_gorizontal,

                  int shag_vertical,
                  int shag_gorizontal)
{

  //создаем итоговую микроматрицу
  macro_massive.createMacroMatrica(yvelichenie, kolichestvo_vertical, kolichestvo_gorizontal);


  //создаем элементарный массив
  ItogMassiv micromas;

  //устанавливаем начальное положения датчика
  int vert_positions = servo_vertical.readMicroseconds();
  int gor_positions = servo_gorizontal.readMicroseconds();

  servo_vertical.writeMicroseconds(micro_shag * nachalo_vertical);
  servo_gorizontal.writeMicroseconds(micro_shag * nachalo_gorizontal);

  int ABS1 = abs(vert_positions - micro_shag * nachalo_vertical);
  int ABS2 = abs(gor_positions - micro_shag * nachalo_gorizontal);
  delay (servo_payza * ABS1 * norma + servo_payza * ABS2 * norma);


  //цикл заполнения итогового массив
  bool gorizontal_servo_vpravo = true;
  for (int nomer_matricy_4x16 = 0;
       nomer_matricy_4x16 < kolichestvo_vertical * kolichestvo_gorizontal; nomer_matricy_4x16++)
  {

    //заполняем элементарный массив значениями температур
    MicroMassive(micromas, yvelichenie, servo_payza, micro_shag, gorizontal_servo_vpravo, payza_chteniya_RAM);

    //определяем и заполняем нужную часть микромассива
    macro_massive.setMacroMatrica(micromas, nomer_matricy_4x16, kolichestvo_gorizontal);


    //движения серво
    int positions, new_positions, ABS;
    if (gorizontal_servo_vpravo && (nomer_matricy_4x16 + 1) % kolichestvo_gorizontal != 0)
    {
      positions = servo_gorizontal.readMicroseconds();
      new_positions = positions - micro_shag * shag_gorizontal;

      servo_gorizontal.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);
    }

    if (!gorizontal_servo_vpravo && (nomer_matricy_4x16 + 1) % kolichestvo_gorizontal != 0)
    {
      positions = servo_gorizontal.readMicroseconds();
      //с коменсацией для микромассива при обратном движении
      new_positions = positions + micro_shag * shag_gorizontal + micro_shag * (yvelichenie - 1);

      servo_gorizontal.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);
    }

    //перемещение вниз
    if ((nomer_matricy_4x16 + 1) != kolichestvo_vertical * kolichestvo_gorizontal &&
        (nomer_matricy_4x16 + 1) % kolichestvo_gorizontal == 0)
    {
      positions = servo_vertical.readMicroseconds();
      //+коменсация для микромассива по вертикали
      new_positions = positions - micro_shag * shag_vertical - micro_shag * (yvelichenie - 1);

      servo_vertical.writeMicroseconds(new_positions);

      ABS = abs(positions - new_positions);
      delay (servo_payza * ABS * norma);


      gorizontal_servo_vpravo = !gorizontal_servo_vpravo;
      //коменсация для микромассива при обратном движении
      if (!gorizontal_servo_vpravo)
      {
        positions = servo_gorizontal.readMicroseconds();
        new_positions = positions + micro_shag * (yvelichenie - 1);

        servo_gorizontal.writeMicroseconds(new_positions);

        ABS = abs(positions - new_positions);
        delay (servo_payza * ABS * norma);
      }
    }
  }
}



