#include <Servo.h>
#include <Wire.h>

int EEPROM_information[256];
Servo myservo1, myservo2;


void setup() {

  Wire.begin();
  Serial.begin(9600);


  //myservo1.attach(10, 700, 2300);
  //delay (1000);
  //myservo2.attach(9, 700, 2300);
  //delay (2000);



  Wire.beginTransmission(0x50);
  Wire.write(0x00);
  Wire.endTransmission(false);

  Wire.requestFrom(80, 255);
  for (int i = 0; i < 128; i++)
  {
    EEPROM_information[i] = Wire.read();
  }

  Wire.requestFrom(81, 128);
  for (int i = 128; i < 256; i++)
  {
    EEPROM_information[i] = Wire.read();
  }

  //вывод всей считанной из датчика EEPROM
  /*for (int i=0;i<256;i++)
  {
  Serial.print("0x");
  Serial.print(i,HEX);
  Serial.print(": ");
  Serial.print(EEPROM_information[i]);
  Serial.print("\n");
  }*/

}

void loop() {
  //Чтение всей RAM
  for (int RAM = 0; RAM <= 0xFF; RAM++)
  {
    Wire.beginTransmission(0x60); //slave address
    Wire.write(0x02); //command
    Wire.write(RAM); //start adress
    Wire.write(0x01); //step
    Wire.write(0x01); // byte to read
    Wire.endTransmission(false);
    Serial.print("0x");
    Serial.print(RAM, HEX);
    Serial.print(": ");

    Wire.requestFrom(0x60, 2);
    while (Wire.available())
    {
      int c = Wire.read();
      Serial.print(c);
      Serial.print(" ");
    }
    Serial.print("\n");
  }

  //Настройка
  //частота
  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x04); //command
  Wire.write(0xA5); //control LSByte
  Wire.write(0x4F); //LSByte
  Wire.write(0x56); //control MSByte
  Wire.write(0x00); //MSByte
  Wire.endTransmission();

  //регистр
  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x03); //command
  Wire.write(0xB9); //control LSByte
  Wire.write(0x0E); //LSByte
  Wire.write(0x1F); //control MSByte
  Wire.write(0x74); //MSByte
  Wire.endTransmission();
  //---------------------------------







  //Получение данных из RAM
  //Определение PTAT_data
  int PTAT_data;

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x90); //start adress
  Wire.write(0x00); //step
  Wire.write(0x01); // byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 2);
  int PTAT_L = Wire.read();
  int PTAT_H = Wire.read();

  PTAT_data = 256 * PTAT_H + PTAT_L;

  //ИК массив
  int VIR[4][16];

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x00); //start adress
  Wire.write(0x01); //step
  Wire.write(0x40); // byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 128);
  int i = 0, j = 0;
  while (Wire.available())
  {
    if (i == 4)
    {
      i = 0;
      j++;
    }

    int IR_L = Wire.read();
    int IR_H = Wire.read();

    VIR[i][j] = 256 * IR_H + IR_L;
    if (VIR[i][j] > 32767) VIR[i][j] = VIR[i][j] - 65536;
    i++;
  }

  //Компенсация
  int VCP;

  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x91); //start adress
  Wire.write(0x00); //step
  Wire.write(0x01); // byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 2);
  int VCP_L = Wire.read();
  int VCP_H = Wire.read();

  VCP = 256 * VCP_H + VCP_L;
  if (VCP > 32767) VCP = VCP - 65536;
  //---------------------------------------






  //Инициализируем константы из EEPROM и другие
  int Ta_0 = 25;


  int VTH_L = EEPROM_information[0xDA];
  int VTH_H = EEPROM_information[0xDB];
  int VTH = 256 * VTH_H + VTH_L;
  if (VTH > 32767) VTH = VTH - 65536;


  int KT1_L = EEPROM_information[0xDC];
  int KT1_H = EEPROM_information[0xDD];
  int KT1_int = 256 * KT1_H + KT1_L;
  if (KT1_int > 32767) KT1_int = KT1_int - 65536;
  double KT1 = (double)KT1_int / 1024;


  int KT2_L = EEPROM_information[0xDE];
  int KT2_H = EEPROM_information[0xDF];
  int KT2_int = 256 * KT2_H + KT2_L;
  if (KT2_int > 32767) KT2_int = KT2_int - 65536;
  double KT2 = (double)KT2_int / 1048576;


  int A[4][16];
  int B[4][16];
  int da[4][16];

  int cx = 0;
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      A[i][j] = EEPROM_information[cx];
      if (A[i][j] > 127) A[i][j] = A[i][j] - 256;

      B[i][j] = EEPROM_information[0x40 + cx];
      if (B[i][j] > 127) B[i][j] = B[i][j] - 256;

      da[i][j] = EEPROM_information[0x80 + cx];
      cx++;
    }
  }

  //заплатка
  A[0][0] = A[3][0];
  da[0][0] = da[3][0];
  //--------



  int ACP = EEPROM_information[0xD4];
  if (ACP > 127) ACP = ACP - 256;


  int BCP = EEPROM_information[0xD5];
  if (BCP > 127) BCP = BCP - 256;


  int aCP_L = EEPROM_information[0xD6];
  int aCP_H = EEPROM_information[0xD7];
  int aCP = 256 * aCP_H + aCP_L;


  int TGC = EEPROM_information[0xD8];
  //Определение TGC с сенсора
  Wire.beginTransmission(0x60); //slave address
  Wire.write(0x02); //command
  Wire.write(0x91); //start adress
  Wire.write(0x00); //step
  Wire.write(0x01); // byte to read
  Wire.endTransmission(false);

  Wire.requestFrom(0x60, 2);
  int TGC_L = Wire.read();
  int TGC_H = Wire.read();

  TGC = TGC_L;
  if (TGC > 127) TGC = TGC - 256;


  int Bi_scale = EEPROM_information[0xD9];


  int a0_L = EEPROM_information[0xE0];
  int a0_H = EEPROM_information[0xE1];
  int a0 = 256 * a0_H + a0_L;


  int a0_scale = EEPROM_information[0xE2];


  int da_scale = EEPROM_information[0xE3];


  int E_L = EEPROM_information[0xE4];
  int E_H = EEPROM_information[0xE5];
  double E = (256 * E_H + E_L) / 32768;
  //---------------------------------------------








  //Вычисление температуры и вывод
  //Определение Та
  double Ta = (-KT1 + sqrt(KT1 * KT1 - 4 * KT2 * (VTH - PTAT_data))) / (2 * KT2) + Ta_0;
  //--------------------------------------------











  //Определение смещения
  double VCP_off_comp = VCP - (ACP + BCP * (Ta - Ta_0) / pow(2, Bi_scale));

  double VIR_off_comp[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_off_comp[i][j] = VIR[i][j] - (A[i][j] + B[i][j] * (Ta - Ta_0) / pow(2, Bi_scale));
    }
  }
  //------------------------------------






  //Определение термоградиента
  double VIR_TGC_comp[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_TGC_comp[i][j] = VIR_off_comp[i][j] - ((TGC / 32) * VCP_off_comp);
    }
  }
  //------------------------------------






  //Компенсация излучения
  double VIR_compensated[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      VIR_compensated[i][j] = VIR_TGC_comp[i][j] / E;
    }
  }
  //------------------------------------








  //Определение альфы
  double a[4][16];
  double a_const = (a0 - TGC * aCP / 32) / pow(2, a0_scale);
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      a[i][j] = a_const + da[i][j] / pow(2, da_scale);
    }
  }
  //------------------------------------







  //Расчет To
  double To[4][16];
  for (int j = 0; j < 16; j++)
  {
    for (int i = 0; i < 4; i++)
    {
      To[i][j] = pow(VIR_compensated[i][j] / a[i][j] + pow(Ta + 273.15, 4), (double)1 / 4) - 273.15;
    }
  }
  //------------------------------------



  Serial.print(Ta);
  Serial.print(" C ");
  Serial.print(TGC);
  Serial.print(" ");
  Serial.print(TGC_L);
  Serial.print(" ");
  Serial.print(TGC_H);
  Serial.print(" \n");

  //Serial.print(PTAT_data);
  //Serial.print(" \n");

  for (int i = 0; i < 4; i++)
  {
    for (int j = 0; j < 16; j++)
    {
      Serial.print(To[i][j]);
      Serial.print(" C ");
      //Serial.print(VIR[i][j]);
      //Serial.print(" ");
    }
    Serial.print("\n");
  }
  Serial.print("\n");

  delay(1000);
}

