﻿#include "itogmassiveforarduino.h"

ItogMassiv::ItogMassiv()
{
    X=-1;
    Y=-1;
    shag=0;

    popravka1=0;
    popravka2=0;
}

ItogMassiv::~ItogMassiv()
{
    //проверка была ли удалена матрица раньше
    if (X!=-1&&Y!=-1) this->deleteMatrica();
}

void ItogMassiv::createMicroMatrica(int yvelichenie)
{
    //увеличение матрицы не может быть меньше 1
    if (yvelichenie<1) return;

    //форматируем матрицу, если новый размер не совпал
    if (X!=4*yvelichenie&&Y!=16*yvelichenie)
    {
        shag = yvelichenie;

        //проверка была ли создана матрица раньше
        if (X!=-1&&Y!=-1) this->deleteMatrica();


        X=4*shag;
        Y=16*shag;

        itog_mas=new double *[X];
        for (int i=0;i<X;i++)
            itog_mas[i]=new double [Y];
    }

    //заполняем массив нулями
    for (int j=0;j<Y;j++)
        for (int i=0;i<X;i++)
        {
            itog_mas[i][j]=0;
        }
}

void ItogMassiv::createMacroMatrica(int yvelichenie,
                                    int vert_coef,
                                    int gor_coef)
{

    //увеличение матрицы не может быть меньше 1
    if (yvelichenie<1) return;
    //количество элементов тоже
    if (vert_coef<1) return;
    if (gor_coef<1) return;




    //форматируем матрицу, если новый размер не совпал
    if (X!=4*yvelichenie*vert_coef ||
            Y!=16*yvelichenie*gor_coef)
    {
        shag = yvelichenie;

        //проверка была ли создана матрица раньше
        if (X!=-1&&Y!=-1) this->deleteMatrica();


        X=4*shag*vert_coef;
        Y=16*shag*gor_coef;

        itog_mas=new double *[X];
        for (int i=0;i<X;i++)
            itog_mas[i]=new double [Y];
    }

    //заполняем массив нулями
    for (int j=0;j<Y;j++)
        for (int i=0;i<X;i++)
        {
            itog_mas[i][j]=0;
        }
}

void ItogMassiv::deleteMatrica()
{
    for (int i=0;i<X;i++)
        delete [] itog_mas[i];
    delete [] itog_mas;
    X=-1;
    Y=-1;
}

void ItogMassiv::setMicroMatrica(double mas[4][16], int count)
{
    if (count<0) return;

    if (count==0)
    {
        popravka1=0;
        popravka2=0;
        chet_nechet=false;
    }



    //печатная головка смещается вниз

    if ((count)%(shag)==0&&shag>1&&count>0)
    {
        popravka1=popravka1+shag;
        popravka2++;
        chet_nechet=!chet_nechet;
    }
    count=count-popravka1;

    if(chet_nechet) count=shag-count-1;



    for (int j=count;j<Y;j+=shag)
        for (int i=popravka2;i<X;i+=shag)
        {
	    //учтена инверсия по горизонтали (15*shag-j)
            itog_mas[i][j]=mas[4*i/X][15-16*j/Y];
        }
}

void ItogMassiv::setMacroMatrica(ItogMassiv &micromas, int count, int gor_coef)
{
    if (count<0) return;

    if (count==0)
    {
        popravka1=0;
        popravka2=0;
        chet_nechet=false;
    }



    //печатная головка смещается вниз

    if (count%gor_coef==0&&gor_coef>0&&count>0)
    {
        popravka1=popravka1+gor_coef;
        popravka2+=4*shag;
        chet_nechet=!chet_nechet;
    }
    count=count-popravka1;

    if(chet_nechet) count=gor_coef-count-1;


    for (int j=count*16*shag;j<16*shag*(count+1);j++)
        for (int i=popravka2;i<popravka2+4*shag;i++)
        {
            itog_mas[i][j]=micromas.getTemp(i-popravka2,j-count*16*shag);
        }
}
