#include "mainwindow.h"
#include "ui_mainwindow.h"




//отоброжение в ComboBox всех доступных COM портов на момент запуска
void MainWindow::refresh_COM_ports()
{
    QList<QSerialPortInfo> AvailablePortsList = QSerialPortInfo::availablePorts();

    ui->COMComboBox->addItem("Отключено");
    for (int i=0;i < AvailablePortsList.count();i++)
    {
        ui->COMComboBox->addItem(AvailablePortsList.at(i).portName());
        if (AvailablePortsList.at(i).portName()==COM)
        {
            ui->COMComboBox->setCurrentIndex(ui->COMComboBox->count()-1);
            //выводим на экран информацию о порте
            ui->COMInformationOutputTextBrowser->setFont(QFont("Inconsolata",8,QFont::Normal));
            ui->COMInformationOutputTextBrowser->setTextColor(Qt::black);
            this->get_COM_ports_information(COM);
        }
    }
    fake_COM=false;
    COM="";
}

//получение информации о COM-порте
void MainWindow::get_COM_ports_information(QString PortNameForGetPort)
{
    QString output;
    QSerialPortInfo PortInformation(PortNameForGetPort);

    if (PortInformation.description()!="")
        output=output+"Название: "+PortInformation.description()+"\n";
    else
        output=output+"Название: отсутствует.\n";

    if (PortInformation.manufacturer()!="")
        output=output+"Производитель: "+PortInformation.manufacturer()+"\n";
    else
        output=output+"Производитель: отсутствует.\n";

    if (QString::number(PortInformation.productIdentifier())!=0)
        output=output+"ИД продукта: "+QString::number(PortInformation.productIdentifier())+"\n";
    else
        output=output+"ИД продукта: отсутствует.\n";

    if (QString::number(PortInformation.vendorIdentifier())!=0)
        output=output+"ИД поставщика: "+QString::number(PortInformation.vendorIdentifier())+"\n";
    else
        output=output+"ИД поставщика: отсутствует.\n";

    if (PortInformation.serialNumber()!="")
        output=output+"Серийный номер: "+PortInformation.serialNumber()+"\n";
    else
        output=output+"Серийный номер: отсутствует.\n";

    if (PortInformation.systemLocation()!="")
        output=output+"Системное расположение: "+PortInformation.systemLocation()+"\n";
    else
        output=output+"Системное расположение: отсутствует.\n";



    ui->COMInformationOutputTextBrowser->setText(output);
}

//вывод доступных скоростей передачи данных COM-порта в ComboBox
void MainWindow::get_speed_COM_ports()
{
    QList<qint32> AvailableSpeedList = QSerialPortInfo::standardBaudRates();

    for (int i=0;i < AvailableSpeedList.count();i++)
    {
        ui->COMSpeedComboBox->addItem(QString::number(AvailableSpeedList.at(i)));
    }

    //определение скорости "по умолчанию"
    for (int i=0;i < ui->COMSpeedComboBox->count();i++)
    {
        if (ui->COMSpeedComboBox->itemText(i)=="115200")
        {
            ui->COMSpeedComboBox->setCurrentIndex(i);
        }
    }
}

void MainWindow::on_COMComboBox_currentTextChanged(const QString &COMPortName)
{
    if (ui->COMComboBox->count()==0) return;

    //закрываем порт
    if (ui->COMComboBox->currentIndex()==0)
    {
        if (!fake_COM)
        {
            //откл кнопки "Запуск"
            if (ui->radioButton->isChecked()) ui->pushButton->setEnabled(false);

            if (CommandPort->isOpen()) CommandPort->close();

            ui->COMInformationOutputTextBrowser->setTextColor(0xFFFF4F00);
            ui->COMInformationOutputTextBrowser->setFont(QFont("Inconsolata",15,QFont::Bold));
            ui->COMInformationOutputTextBrowser->setText("\n\n Подключите термосканер!");

            if (_COMChat=="")
            {
                real_data=QDateTime::currentDateTime();
                _COMChat=_COMChat+real_data.toString("dd.MM.yy [hh:mm:ss.zzz]: ")+"Программа запущена.\r\n";
                ui->chatWithCOMTextBrowser->setText(_COMChat);
                ui->chatWithCOMTextBrowser->verticalScrollBar()->
                        setValue(ui->chatWithCOMTextBrowser->verticalScrollBar()->maximum());

                log.close();
                log.open(QIODevice::WriteOnly);
                log.write(_COMChat.toLocal8Bit());
                log.close();
                log.open(QIODevice::Append);
            }
            else
            {
                real_data=QDateTime::currentDateTime();
                _COMChat=_COMChat+real_data.toString("dd.MM.yy [hh:mm:ss.zzz]: ")+"Устройство отключено.\r\n";
                ui->chatWithCOMTextBrowser->setText(_COMChat);
                ui->chatWithCOMTextBrowser->verticalScrollBar()->
                        setValue(ui->chatWithCOMTextBrowser->verticalScrollBar()->maximum());

                log.close();
                log.open(QIODevice::WriteOnly);
                log.write(_COMChat.toLocal8Bit());
                log.close();
                log.open(QIODevice::Append);
            }

            COM="";
        }

        return;
    }

    if (COM=="")
    {
        if (ui->radioButton->isChecked()) ui->pushButton->setEnabled(true);

        //выводим на экран информацию о порте
        ui->COMInformationOutputTextBrowser->setFont(QFont("Inconsolata",8,QFont::Normal));
        ui->COMInformationOutputTextBrowser->setTextColor(Qt::black);
        this->get_COM_ports_information(COMPortName);



        //открываем порт
        CommandPort=new QSerialPort;
        CommandPort->setPortName(COMPortName);
        CommandPort->setBaudRate(ui->COMSpeedComboBox->itemText(ui->COMSpeedComboBox->currentIndex()).toInt());
        if(!CommandPort->open(QIODevice::ReadWrite))
        {
            real_data=QDateTime::currentDateTime();
            _COMChat=_COMChat+real_data.toString("dd.MM.yy [hh:mm:ss.zzz]: ")+"Устройство недоступно.\r\n";
            ui->chatWithCOMTextBrowser->setText(_COMChat);
            ui->chatWithCOMTextBrowser->verticalScrollBar()->
                    setValue(ui->chatWithCOMTextBrowser->verticalScrollBar()->maximum());

            log.close();
            log.open(QIODevice::WriteOnly);
            log.write(_COMChat.toLocal8Bit());
            log.close();
            log.open(QIODevice::Append);

            fake_COM=true;
            ui->pushButton->setEnabled(false);
            ui->COMComboBox->setCurrentIndex(0);
            fake_COM=false;
            return;
        }else
        {
            real_data=QDateTime::currentDateTime();
            _COMChat=_COMChat+real_data.toString("dd.MM.yy [hh:mm:ss.zzz]: ")+"Устройство подключено.\r\n";
            ui->chatWithCOMTextBrowser->setText(_COMChat);
            ui->chatWithCOMTextBrowser->verticalScrollBar()->
                    setValue(ui->chatWithCOMTextBrowser->verticalScrollBar()->maximum());

            log.close();
            log.open(QIODevice::WriteOnly);
            log.write(_COMChat.toLocal8Bit());
            log.close();
            log.open(QIODevice::Append);
        }
    }
}

void MainWindow::on_refreshCOMButton_clicked()
{

    COM=ui->COMComboBox->itemText(ui->COMComboBox->currentIndex());
    fake_COM=true;
    ui->COMComboBox->clear();
    ui->COMSpeedComboBox->clear();

    this->refresh_COM_ports();
    this->get_speed_COM_ports();
}

void MainWindow::on_radioButton_3_clicked()
{
    ui->pushButton->setEnabled(true);
}

void MainWindow::on_radioButton_clicked()
{
    ui->pushButton->setEnabled(false);
}
