#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtSerialPort/QtSerialPort>
#include <QGraphicsScene>
#include <itogmassive.h>
#include <visualtermo.h>
#include "QScrollBar"
#include <QFileDialog>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:

    //Функции COM-порта
    void refresh_COM_ports();

    void get_COM_ports_information(QString );

    void on_COMComboBox_currentTextChanged(const QString &arg1);

    void get_speed_COM_ports();

    void on_refreshCOMButton_clicked();

    //Функции визуализатора
    void on_horizontalSlider_valueChanged(int value);

    void on_horizontalSlider_2_valueChanged(int value);

    void on_horizontalSlider_3_valueChanged(int value);

    void on_checkBox_clicked(bool checked);

    void resizeEvent(QResizeEvent * );

    void showEvent(QShowEvent * );

    void mousePressEvent(QMouseEvent *);


    void on_pushButton_clicked();

    void on_radioButton_3_clicked();

    void on_radioButton_clicked();


    void on_pushButton_5_clicked();

    void on_pushButton_6_clicked();

    void on_horizontalSlider_7_valueChanged(int value);

    void on_lineEdit_3_editingFinished();


    void on_checkBox_2_clicked(bool checked);

    void on_pushButton_4_clicked();

private:
    Ui::MainWindow *ui;

    QString cur;

    QSerialPort *CommandPort;
    QString _COMChat;
    QString COM;
    bool fake_COM;

    QFile log;
    ItogMassiv *itog_mas;

    QGraphicsScene *termo_shkala;
    VisualTermo *termo_matrica;

    QDateTime real_data;
};

#endif // MAINWINDOW_H
