#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QGraphicsItem>
#include <QMouseEvent>

void MainWindow::on_horizontalSlider_valueChanged(int value)
{
    int delta=0;
    if (ui->checkBox->isChecked())
    {
        delta=ui->label_3->text().toDouble()*1536;
        if (value<ui->horizontalSlider_2->value()-delta) ui->horizontalSlider_2->setValue(ui->horizontalSlider->value()+delta);
    }



    if (value==ui->horizontalSlider_2->maximum())
    {
        ui->horizontalSlider->setValue(ui->horizontalSlider->value()-1);
    }
    else
    {
        if (value>ui->horizontalSlider_2->value()-1) ui->horizontalSlider_2->setValue(ui->horizontalSlider->value()+1);
    }




    QRectF rect_do = termo_shkala->sceneRect();

    zadaem_chisla_na_shkale(termo_shkala,
                            ui->horizontalSlider->value(),ui->horizontalSlider_2->value());
    ui->graphicsView_2->setScene(termo_shkala);

    QRectF rect_posle = termo_shkala->sceneRect();
    if (rect_do.height()!=rect_posle.height()||rect_do.width()!=rect_posle.width())
        ui->graphicsView_2->fitInView(termo_shkala->sceneRect(),Qt::KeepAspectRatio);




    stroim_kartinky(itog_mas,termo_matrica,
                         ui->horizontalSlider->value(),ui->horizontalSlider_2->value());
    ui->graphicsView->setScene(termo_matrica);

}

void MainWindow::on_horizontalSlider_2_valueChanged(int value)
{

    int delta=0;
    if (ui->checkBox->isChecked())
    {
        delta=ui->label_3->text().toDouble()*1536;
        if (value>ui->horizontalSlider->value()+delta) ui->horizontalSlider->setValue(ui->horizontalSlider_2->value()-delta);
    }


    if (value==ui->horizontalSlider->minimum())
    {
        ui->horizontalSlider_2->setValue(ui->horizontalSlider_2->value()+1);
    }
    else
    {
        if (value<ui->horizontalSlider->value()+1) ui->horizontalSlider->setValue(ui->horizontalSlider_2->value()-1);
    }


    QRectF rect_do = termo_shkala->sceneRect();

    zadaem_chisla_na_shkale(termo_shkala,
                            ui->horizontalSlider->value(),ui->horizontalSlider_2->value());
    ui->graphicsView_2->setScene(termo_shkala);

    QRectF rect_posle = termo_shkala->sceneRect();
    if (rect_do.height()!=rect_posle.height()||rect_do.width()!=rect_posle.width())
        ui->graphicsView_2->fitInView(termo_shkala->sceneRect(),Qt::KeepAspectRatio);


    stroim_kartinky(itog_mas,termo_matrica,
                         ui->horizontalSlider->value(),ui->horizontalSlider_2->value());
    ui->graphicsView->setScene(termo_matrica);

}

void MainWindow::on_horizontalSlider_3_valueChanged(int value)
{
    if (value==0) ui->label_3->setText(QString::number(0.01));
    if (value==1) ui->label_3->setText(QString::number(0.1));
    if (value==2) ui->label_3->setText(QString::number(1));
    ui->horizontalSlider->valueChanged(ui->horizontalSlider->value());
}

void MainWindow::on_checkBox_clicked(bool checked)
{
    if (checked==true)
    {
        ui->horizontalSlider_3->setEnabled(true);
        ui->label_3->setEnabled(true);
        ui->horizontalSlider->valueChanged(ui->horizontalSlider->value());
    }

    if (checked==false)
    {
        ui->horizontalSlider_3->setEnabled(false);
        ui->label_3->setEnabled(false);
    }
}

void MainWindow::showEvent(QShowEvent *)
{
    ui->graphicsView->fitInView(termo_matrica->sceneRect(),Qt::KeepAspectRatio);
    ui->graphicsView_2->fitInView(termo_shkala->sceneRect(),Qt::KeepAspectRatio);
}

void MainWindow::resizeEvent(QResizeEvent * )
{
    ui->graphicsView->fitInView(termo_matrica->sceneRect(),Qt::KeepAspectRatio);
    ui->graphicsView_2->fitInView(termo_shkala->sceneRect(),Qt::KeepAspectRatio);
}

void MainWindow::mousePressEvent(QMouseEvent *event)
{
    QPointF coord=termo_matrica->mouse_on_pixel_pos;
    int x =coord.x();
    int y =coord.y();

    //сбрасываем значения, чтобы они не остались,
    //если ткнули в области отображния
    termo_matrica->mouse_on_pixel_pos.setX(-1);
    termo_matrica->mouse_on_pixel_pos.setY(-1);


    if (0<=x&&x<itog_mas->y()&&0<=y&&y<itog_mas->x())
    {
        QList<QGraphicsItem*> items = termo_matrica->items();

        //допустимое количество точек 100 штук
        if (items.count()<100)
        {
            if (event->button()==Qt::LeftButton)
            {
                QString chislo_print=QString::number(itog_mas->getTemp(y,x),'f',2);

                int max;
                if (termo_matrica->width()>termo_matrica->height()) max=termo_matrica->width();
                else max=termo_matrica->height();

                QList<QGraphicsItem*> list;
                list.append(termo_matrica->addEllipse(x-max/64,y-max/64,1+max/33,1+max/33,
                                                      QPen(Qt::black, 0.1,  Qt::SolidLine, Qt::RoundCap, Qt::RoundJoin),
                                                      QBrush(Qt::black,Qt::SolidPattern)));

                QGraphicsTextItem *pic_text;
                pic_text=termo_matrica->addText(chislo_print,QFont("Inconsolata",1+max/33,QFont::Bold));
                pic_text->setPos(-3+x+max/33,-6+y-max/33);


                list.append(pic_text);

                QGraphicsItemGroup* group = termo_matrica->createItemGroup(list);
                group->setFlag(QGraphicsItem::ItemIsSelectable,true);


                termo_matrica->setSceneRect(termo_matrica->itemsBoundingRect());
                ui->graphicsView->fitInView(termo_matrica->sceneRect(),Qt::KeepAspectRatio);
            }
        }


        if (event->button()==Qt::RightButton)
        {
            QPainterPath path;
            path.addRect(x,y,1,1);
            termo_matrica->setSelectionArea(path);

            QList<QGraphicsItem*> list = termo_matrica->selectedItems();

            for (int i=0;i<list.size();i++)
            {
                termo_matrica->removeItem(list.at(i));
            }

            termo_matrica->setSceneRect(termo_matrica->itemsBoundingRect());
            ui->graphicsView->fitInView(termo_matrica->sceneRect(),Qt::KeepAspectRatio);

        }

    }
}
